/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.pl.productBatch.controller;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import liquibase.pro.packaged.P;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.secure.BladeUser;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.pl.product.entity.ProductEntity;
import org.springblade.modules.pl.product.service.IProductService;
import org.springblade.modules.pl.productModel.entity.ProductModelEntity;
import org.springblade.modules.pl.productModel.service.IProductModelService;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.pl.productBatch.entity.ProductBatchEntity;
import org.springblade.modules.pl.productBatch.vo.ProductBatchVO;
import org.springblade.modules.pl.productBatch.excel.ProductBatchExcel;
import org.springblade.modules.pl.productBatch.wrapper.ProductBatchWrapper;
import org.springblade.modules.pl.productBatch.service.IProductBatchService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.excel.util.ExcelUtil;
import org.springblade.core.tool.constant.BladeConstant;
import springfox.documentation.annotations.ApiIgnore;

import java.util.Date;
import java.util.Map;
import java.util.List;
import javax.servlet.http.HttpServletResponse;

/**
 * 产品入库批次表 控制器
 *
 * @author BladeX
 * @since 2023-12-05
 */
@RestController
@AllArgsConstructor
@RequestMapping("pl-productBatch/productBatch")
@Api(value = "产品入库批次表", tags = "产品入库批次表接口")
public class ProductBatchController extends BladeController {

	private final IProductBatchService productBatchService;
	private final IProductService productService;
	private final IProductModelService productModelService;

	/**
	 * 产品入库批次表 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入productBatch")
	public R<ProductBatchVO> detail(ProductBatchEntity productBatch) {
		ProductBatchEntity detail = productBatchService.getOne(Condition.getQueryWrapper(productBatch));
		ProductModelEntity productModel = productModelService.getOne(Wrappers.<ProductModelEntity>lambdaQuery().eq(ProductModelEntity::getId,detail.getProductModelId()));
		List<ProductEntity> productEntityList = productService.list(Wrappers.<ProductEntity>lambdaQuery().eq(ProductEntity::getBatchId,detail.getId()));
		ProductBatchVO productBatchVO = ProductBatchWrapper.build().entityVO(detail);
		productBatchVO.setDetails(productEntityList);
		productBatchVO.setInStockFormItem(productModel.getInStockFormItem());
		return R.data(productBatchVO);
	}
	/**
	 * 产品入库批次表 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入productBatch")
	public R<IPage<ProductBatchVO>> list(@ApiIgnore @RequestParam Map<String, Object> productBatch, Query query) {
		query.setDescs("create_time");
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			productBatch.put("factory_id",user.getFactoryId());
		}
		String qrCode= "";
		if(productBatch.get("qrCode")!=null){
			qrCode = (String) productBatch.get("qrCode");
			productBatch.remove("qrCode");
		}
		QueryWrapper<ProductBatchEntity> queryWrapper = Condition.getQueryWrapper(productBatch, ProductBatchEntity.class);
		if(StringUtil.isNotBlank(qrCode)){
			queryWrapper.inSql("id","select batch_id from pl_product where is_deleted = 0 and qr_code like '%"+ qrCode+"%'");
		}
		IPage<ProductBatchEntity> pages = productBatchService.page(Condition.getPage(query),queryWrapper );
		return R.data(ProductBatchWrapper.build().pageVO(pages));
	}

	/**
	 * 产品入库批次表 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入productBatch")
	public R<IPage<ProductBatchVO>> page(ProductBatchVO productBatch, Query query) {
		IPage<ProductBatchVO> pages = productBatchService.selectProductBatchPage(Condition.getPage(query), productBatch);
		return R.data(pages);
	}

	/**
	 * 产品入库批次表 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入productBatch")
	public R save(@Valid @RequestBody ProductBatchEntity productBatch) {
		return R.status(productBatchService.save(productBatch));
	}

	/**
	 * 产品入库批次表 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入productBatch")
	public R update(@Valid @RequestBody ProductBatchEntity productBatch) {
		return R.status(productBatchService.updateById(productBatch));
	}

	/**
	 * 产品入库批次表 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入productBatch")
	public R submit(@Valid @RequestBody ProductBatchVO productBatch) {
		return productBatchService.submit(productBatch);
	}
	/**
	 * 产品入库批次表 变更
	 */
	@PostMapping("/change")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入productBatch")
	public R change(@Valid @RequestBody ProductBatchVO productBatch) {
		return productBatchService.change(productBatch);
	}

	/**
	 * 产品入库批次表 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(productBatchService.deleteLogic(Func.toLongList(ids)));
	}


	/**
	 * 导出数据
	 */
	@GetMapping("/export-productBatch")
	@ApiOperationSupport(order = 9)
	@ApiOperation(value = "导出数据", notes = "传入productBatch")
	public void exportProductBatch(@ApiIgnore @RequestParam Map<String, Object> productBatch, BladeUser bladeUser, HttpServletResponse response) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			productBatch.put("factory_id",user.getFactoryId());
		}
		QueryWrapper<ProductBatchEntity> queryWrapper = Condition.getQueryWrapper(productBatch, ProductBatchEntity.class);
		//if (!AuthUtil.isAdministrator()) {
		//	queryWrapper.lambda().eq(ProductBatch::getTenantId, bladeUser.getTenantId());
		//}
		queryWrapper.lambda().eq(ProductBatchEntity::getIsDeleted, BladeConstant.DB_NOT_DELETED);
		List<ProductBatchExcel> list = productBatchService.exportProductBatch(queryWrapper);
		ExcelUtil.export(response, "产品入库批次表数据" + DateUtil.time(), "产品入库批次表数据表", list, ProductBatchExcel.class);
	}

}
